# ozlem cetinoglu - 29 feb 2016
#
# reads in the original tweets and their edit transcripts
# and outputs the edited version
#
#
# usage:
# perl convert_original_to_edited.pl -i all_cs_idtweet.tab  -t all_cs_transcript.tab > all_cs_idtweet_norm.auto

use strict;
use Getopt::Std ;


use utf8;	# utf8 in the code
use open ':encoding(utf8)';
binmode STDERR,":encoding(utf8)";
binmode STDOUT,":encoding(utf8)";
binmode STDIN,":encoding(utf8)";


my ($usage) = <<EOT

  perl convert_original_to_edited.pl -i <originalFile>  -t <editTranscipt>
 	-h : help:		print this help text and exit
EOT
;


getopts('i:t:h');
our($opt_i, $opt_t, $opt_h);

((defined $opt_h) or (! defined $opt_i) or (! defined $opt_t)) and die $usage ;


my $origFile = $opt_i;
my $transcriptFile = $opt_t;

open ORIGFILE, $origFile or die "cannot open $origFile: $!\n";
open TRANSFILE, $transcriptFile or die "cannot open $transcriptFile: $!\n";

my $i = 0;
my @transcript = ();

my $tweetID = 0;
my @chars = ();
my @actions = ();

while (<TRANSFILE>){
	chomp();
	($tweetID, @actions) = split(/\t/);
	$transcript[$i] = join("\t", @actions);
	$i++; 	
}

$i = 0;
my $orig = '';

while(<ORIGFILE>){

	chomp();
	($tweetID, $orig) = split(/\t/);
	@chars = split(//, $orig);
	@actions = split(/\t/, $transcript[$i]);

	my $k = 0;

	print "$tweetID\t";

	for (my $j=0; $j <= length($transcript[$i]); $j++){
		if ($actions[$j] eq 'none'){
			print "$chars[$k]";
			$k++;		
		}
		elsif ($actions[$j] =~ /^sub\((.)\,(.)\)$/){
			print "$2";
			$k++;		
		}
		elsif ($actions[$j] =~ /^ins\((.)\)$/){
			print "$1";	
		}
		elsif ($actions[$j] =~ /^del\((.)\)$/){
			$k++;	
		}
		#else {print "\naction $actions[$j] is not recognized\n";}
	}
	print "\n";
	$i++;
}

close ORIGFILE;
close EDITEDFILE;



